Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/moleculelist.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -7,4 +7,5 @@
 #include <cstring>
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "bond.hpp"
@@ -19,4 +20,5 @@
 #include "memoryallocator.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 /*********************************** Functions for class MoleculeListClass *************************/
@@ -24,5 +26,6 @@
 /** Constructor for MoleculeListClass.
  */
-MoleculeListClass::MoleculeListClass()
+MoleculeListClass::MoleculeListClass(World *_world) :
+  world(_world)
 {
   // empty lists
@@ -35,10 +38,10 @@
 MoleculeListClass::~MoleculeListClass()
 {
-  Log() << Verbose(3) << this << ": Freeing ListOfMolcules." << endl;
+  DoLog(3) && (Log() << Verbose(3) << this << ": Freeing ListOfMolcules." << endl);
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
-    Log() << Verbose(4) << "ListOfMolecules: Freeing " << *ListRunner << "." << endl;
-    delete (*ListRunner);
-  }
-  Log() << Verbose(4) << "Freeing ListOfMolecules." << endl;
+    DoLog(4) && (Log() << Verbose(4) << "ListOfMolecules: Freeing " << *ListRunner << "." << endl);
+    world->destroyMolecule(*ListRunner);
+  }
+  DoLog(4) && (Log() << Verbose(4) << "Freeing ListOfMolecules." << endl);
   ListOfMolecules.clear(); // empty list
 };
@@ -137,9 +140,9 @@
  * \param *out output stream
  */
-void MoleculeListClass::Enumerate(ofstream *out)
-{
-  element* Elemental = NULL;
+void MoleculeListClass::Enumerate(ostream *out)
+{
   atom *Walker = NULL;
-  int Counts[MAX_ELEMENTS];
+  periodentafel *periode = World::getInstance().getPeriode();
+  std::map<atomicNumber_t,unsigned int> counts;
   double size=0;
   Vector Origin;
@@ -153,7 +156,4 @@
     Origin.Zero();
     for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
-      // reset element counts
-      for (int j = 0; j<MAX_ELEMENTS;j++)
-        Counts[j] = 0;
       // count atoms per element and determine size of bounding sphere
       size=0.;
@@ -161,15 +161,15 @@
       while (Walker->next != (*ListRunner)->end) {
         Walker = Walker->next;
-        Counts[Walker->type->Z]++;
-        if (Walker->x.DistanceSquared(&Origin) > size)
-          size = Walker->x.DistanceSquared(&Origin);
+        counts[Walker->type->getNumber()]++;
+        if (Walker->x.DistanceSquared(Origin) > size)
+          size = Walker->x.DistanceSquared(Origin);
       }
       // output Index, Name, number of atoms, chemical formula
       (*out) << ((*ListRunner)->ActiveFlag ? "*" : " ") << (*ListRunner)->IndexNr << "\t" << (*ListRunner)->name << "\t\t" << (*ListRunner)->AtomCount << "\t";
-      Elemental = (*ListRunner)->elemente->end;
-      while(Elemental->previous != (*ListRunner)->elemente->start) {
-        Elemental = Elemental->previous;
-        if (Counts[Elemental->Z] != 0)
-          (*out) << Elemental->symbol << Counts[Elemental->Z];
+
+      std::map<atomicNumber_t,unsigned int>::reverse_iterator iter;
+      for(iter=counts.rbegin(); iter!=counts.rend();++iter){
+        atomicNumber_t Z =(*iter).first;
+        (*out) << periode->FindElement(Z)->getSymbol() << (*iter).second;
       }
       // Center and size
@@ -213,5 +213,5 @@
   // remove src
   ListOfMolecules.remove(srcmol);
-  delete(srcmol);
+  World::getInstance().destroyMolecule(srcmol);
   return true;
 };
@@ -315,5 +315,5 @@
   Tesselation *TesselStruct = NULL;
   if ((srcmol == NULL) || (mol == NULL)) {
-    eLog() << Verbose(1) << "Either fixed or variable molecule is given as NULL." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Either fixed or variable molecule is given as NULL." << endl);
     return false;
   }
@@ -323,5 +323,5 @@
   FindNonConvexBorder(mol, TesselStruct, (const LinkedCell *&)LCList, 4., NULL);
   if (TesselStruct == NULL) {
-    eLog() << Verbose(1) << "Could not tesselate the fixed molecule." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Could not tesselate the fixed molecule." << endl);
     return false;
   }
@@ -340,7 +340,7 @@
   while (Walker->next != srcmol->end) {
     Walker = Walker->next;
-    Log() << Verbose(2) << "INFO: Current Walker is " << *Walker << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "INFO: Current Walker is " << *Walker << "." << endl);
     if (!TesselStruct->IsInnerPoint(Walker->x, LCList)) {
-      CopyAtoms[Walker->nr] = new atom(Walker);
+      CopyAtoms[Walker->nr] = Walker->clone();
       mol->AddAtom(CopyAtoms[Walker->nr]);
       nr++;
@@ -349,5 +349,5 @@
     }
   }
-  Log() << Verbose(1) << nr << " of " << srcmol->AtomCount << " atoms have been merged.";
+  DoLog(1) && (Log() << Verbose(1) << nr << " of " << srcmol->AtomCount << " atoms have been merged.");
 
   // go through all bonds and add as well
@@ -355,5 +355,5 @@
   while(Binder->next != srcmol->last) {
     Binder = Binder->next;
-    Log() << Verbose(3) << "Adding Bond between " << *CopyAtoms[Binder->leftatom->nr] << " and " << *CopyAtoms[Binder->rightatom->nr]<< "." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Adding Bond between " << *CopyAtoms[Binder->leftatom->nr] << " and " << *CopyAtoms[Binder->rightatom->nr]<< "." << endl);
     mol->AddBond(CopyAtoms[Binder->leftatom->nr], CopyAtoms[Binder->rightatom->nr], Binder->BondDegree);
   }
@@ -367,8 +367,8 @@
 void MoleculeListClass::Output(ofstream *out)
 {
-  Log() << Verbose(1) << "MoleculeList: ";
+  DoLog(1) && (Log() << Verbose(1) << "MoleculeList: ");
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++)
-    Log() << Verbose(0) << *ListRunner << "\t";
-  Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << *ListRunner << "\t");
+  DoLog(0) && (Log() << Verbose(0) << endl);
 };
 
@@ -396,5 +396,5 @@
   char *FragmentNumber = NULL;
 
-  Log() << Verbose(1) << "Saving hydrogen saturation correction ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving hydrogen saturation correction ... ");
   // 0. parse in fit constant files that should have the same dimension as the final energy files
   // 0a. find dimension of matrices with constants
@@ -406,5 +406,5 @@
   input.open(line.c_str());
   if (input == NULL) {
-    Log() << Verbose(1) << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+    DoLog(1) && (Log() << Verbose(1) << endl << "Unable to open " << line << ", is the directory correct?" << endl);
     return false;
   }
@@ -423,5 +423,5 @@
     b++;
   }
-  Log() << Verbose(0) << "I recognized " << a << " columns and " << b << " rows, ";
+  DoLog(0) && (Log() << Verbose(0) << "I recognized " << a << " columns and " << b << " rows, ");
   input.close();
 
@@ -444,5 +444,5 @@
     input.open(line.c_str());
     if (input == NULL) {
-      eLog() << Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << endl << "Unable to open " << line << ", is the directory correct?" << endl);
       performCriticalExit();
       return false;
@@ -466,12 +466,12 @@
   }
   for (int k = 0; k < 3; k++) {
-    Log() << Verbose(0) << "Constants " << k << ":" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Constants " << k << ":" << endl);
     for (int j = 0; j < b; j++) {
       for (int i = 0; i < a; i++) {
-        Log() << Verbose(0) << FitConstant[k][i][j] << "\t";
+        DoLog(0) && (Log() << Verbose(0) << FitConstant[k][i][j] << "\t");
       }
-      Log() << Verbose(0) << endl;
-    }
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl);
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
   }
 
@@ -502,5 +502,5 @@
           if ((Runner->type->Z == 1) && (Runner->nr > Walker->nr) && (Binder->GetOtherAtom(Runner) != Binder->GetOtherAtom(Walker))) { // (hydrogens have only one bonding partner!)
             // 4. evaluate the morse potential for each matrix component and add up
-            distance = Runner->x.Distance(&Walker->x);
+            distance = Runner->x.distance(Walker->x);
             //Log() << Verbose(0) << "Fragment " << (*ListRunner)->name << ": " << *Runner << "<= " << distance << "=>" << *Walker << ":" << endl;
             for (int k = 0; k < a; k++) {
@@ -561,5 +561,5 @@
   }
   Free(&FitConstant);
-  Log() << Verbose(0) << "done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   return true;
 };
@@ -578,8 +578,8 @@
   stringstream line;
   atom *Walker = NULL;
-  element *runner = NULL;
+  periodentafel *periode=World::getInstance().getPeriode();
 
   // open file for the force factors
-  Log() << Verbose(1) << "Saving  force factors ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Saving  force factors ... ");
   line << path << "/" << FRAGMENTPREFIX << FORCESFILE;
   ForcesFile.open(line.str().c_str(), ios::out);
@@ -588,12 +588,11 @@
     //output << prefix << "Forces" << endl;
     for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
-      runner = (*ListRunner)->elemente->start;
-      while (runner->next != (*ListRunner)->elemente->end) { // go through every element
-        runner = runner->next;
-        if ((*ListRunner)->ElementsInMolecule[runner->Z]) { // if this element got atoms
+      periodentafel::const_iterator elemIter;
+      for(elemIter=periode->begin();elemIter!=periode->end();++elemIter){
+          if ((*ListRunner)->ElementsInMolecule[(*elemIter).first]) { // if this element got atoms
           Walker = (*ListRunner)->start;
           while (Walker->next != (*ListRunner)->end) { // go through every atom of this element
             Walker = Walker->next;
-            if (Walker->type->Z == runner->Z) {
+            if (Walker->type->getNumber() == (*elemIter).first) {
               if ((Walker->GetTrueFather() != NULL) && (Walker->GetTrueFather() != Walker)) {// if there is a rea
                 //Log() << Verbose(0) << "Walker is " << *Walker << " with true father " << *( Walker->GetTrueFather()) << ", it
@@ -609,8 +608,8 @@
     }
     ForcesFile.close();
-    Log() << Verbose(1) << "done." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "done." << endl);
   } else {
     status = false;
-    Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "failed to open file " << line.str() << "." << endl);
   }
   ForcesFile.close();
@@ -640,5 +639,10 @@
   int FragmentCounter = 0;
   ofstream output;
-
+  double cell_size_backup[6];
+  double * const cell_size = World::getInstance().getDomain();
+
+  // backup cell_size
+  for (int i=0;i<6;i++)
+    cell_size_backup[i] = cell_size[i];
   // store the fragments as config and as xyz
   for (MoleculeList::iterator ListRunner = ListOfMolecules.begin(); ListRunner != ListOfMolecules.end(); ListRunner++) {
@@ -648,5 +652,5 @@
       strcpy(PathBackup, path);
     else {
-      eLog() << Verbose(0) << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "OutputConfigForListOfFragments: NULL default path obtained from config!" << endl);
       performCriticalExit();
     }
@@ -659,9 +663,9 @@
     sprintf(FragmentName, "%s/%s%s.conf.xyz", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
     outputFragment.open(FragmentName, ios::out);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as XYZ ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as XYZ ...");
     if ((intermediateResult = (*ListRunner)->OutputXYZ(&outputFragment)))
-      Log() << Verbose(0) << " done." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
     result = result && intermediateResult;
     outputFragment.close();
@@ -669,11 +673,11 @@
 
     // list atoms in fragment for debugging
-    Log() << Verbose(2) << "Contained atoms: ";
+    DoLog(2) && (Log() << Verbose(2) << "Contained atoms: ");
     Walker = (*ListRunner)->start;
     while (Walker->next != (*ListRunner)->end) {
       Walker = Walker->next;
-      Log() << Verbose(0) << Walker->Name << " ";
-    }
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << Walker->Name << " ");
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
 
     // center on edge
@@ -683,6 +687,6 @@
     for (int k = 0; k < NDIM; k++) {
       j += k + 1;
-      BoxDimension.x[k] = 2.5 * (configuration->GetIsAngstroem() ? 1. : 1. / AtomicLengthToAngstroem);
-      (*ListRunner)->cell_size[j] += BoxDimension.x[k] * 2.;
+      BoxDimension[k] = 2.5 * (configuration->GetIsAngstroem() ? 1. : 1. / AtomicLengthToAngstroem);
+      cell_size[j] = BoxDimension[k] * 2.;
     }
     (*ListRunner)->Translate(&BoxDimension);
@@ -699,9 +703,9 @@
     // and save as config
     sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as config ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as config ...");
     if ((intermediateResult = configuration->Save(FragmentName, (*ListRunner)->elemente, (*ListRunner))))
-      Log() << Verbose(0) << " done." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
     result = result && intermediateResult;
 
@@ -711,9 +715,9 @@
     // and save as mpqc input file
     sprintf(FragmentName, "%s/%s%s.conf", configuration->configpath, FRAGMENTPREFIX, FragmentNumber);
-    Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as mpqc input ...";
+    DoLog(2) && (Log() << Verbose(2) << "Saving bond fragment No. " << FragmentNumber << "/" << FragmentCounter - 1 << " as mpqc input ...");
     if ((intermediateResult = configuration->SaveMPQC(FragmentName, (*ListRunner))))
-      Log() << Verbose(2) << " done." << endl;
+      DoLog(2) && (Log() << Verbose(2) << " done." << endl);
     else
-      Log() << Verbose(0) << " failed." << endl;
+      DoLog(0) && (Log() << Verbose(0) << " failed." << endl);
 
     result = result && intermediateResult;
@@ -722,8 +726,12 @@
     Free(&FragmentNumber);
   }
-  Log() << Verbose(0) << " done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << " done." << endl);
 
   // printing final number
-  Log() << Verbose(2) << "Final number of fragments: " << FragmentCounter << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Final number of fragments: " << FragmentCounter << "." << endl);
+
+  // restore cell_size
+  for (int i=0;i<6;i++)
+    cell_size[i] = cell_size_backup[i];
 
   return result;
@@ -748,5 +756,5 @@
 void MoleculeListClass::DissectMoleculeIntoConnectedSubgraphs(const periodentafel * const periode, config * const configuration)
 {
-  molecule *mol = new molecule(periode);
+  molecule *mol = World::getInstance().createMolecule();
   atom *Walker = NULL;
   atom *Advancer = NULL;
@@ -760,5 +768,5 @@
       Walker = Advancer;
       Advancer = Advancer->next;
-      Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl);
       unlink(Walker);
       Walker->father = Walker;
@@ -773,10 +781,14 @@
     }
     // remove the molecule
-    delete(*MolRunner);
+    World::getInstance().destroyMolecule(*MolRunner);
     ListOfMolecules.erase(MolRunner);
   }
 
   // 1. dissect the molecule into connected subgraphs
-  configuration->BG->ConstructBondGraph(mol);
+  if (!configuration->BG->ConstructBondGraph(mol)) {
+    World::getInstance().destroyMolecule(mol);
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no bonds." << endl);
+    return;
+  }
 
   // 2. scan for connected subgraphs
@@ -785,4 +797,9 @@
   Subgraphs = mol->DepthFirstSearchAnalysis(BackEdgeStack);
   delete(BackEdgeStack);
+  if ((Subgraphs == NULL) || (Subgraphs->next == NULL)) {
+    World::getInstance().destroyMolecule(mol);
+    DoeLog(1) && (eLog()<< Verbose(1) << "There are no atoms." << endl);
+    return;
+  }
 
   // 3. dissect (the following construct is needed to have the atoms not in the order of the DFS, but in
@@ -795,5 +812,5 @@
   molecule **molecules = Malloc<molecule *>(MolCount, "config::Load() - **molecules");
   for (int i=0;i<MolCount;i++) {
-    molecules[i] = (molecule*) new molecule(mol->elemente);
+    molecules[i] = World::getInstance().createMolecule();
     molecules[i]->ActiveFlag = true;
     strncpy(molecules[i]->name, mol->name, MAXSTRINGSIZE);
@@ -802,5 +819,5 @@
       strncat(molecules[i]->name, number, MAXSTRINGSIZE - strlen(mol->name) - 1);
     }
-    cout << "MolName is " << molecules[i]->name << endl;
+    DoLog(1) && (Log() << Verbose(1) << "MolName is " << molecules[i]->name << endl);
     insert(molecules[i]);
   }
@@ -826,14 +843,14 @@
     Walker = mol->start->next;
     if ((Walker->nr <0) || (Walker->nr >= mol->AtomCount)) {
-      eLog() << Verbose(0) << "Index of atom " << *Walker << " is invalid!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Index of atom " << *Walker << " is invalid!" << endl);
       performCriticalExit();
     }
     FragmentCounter = MolMap[Walker->nr];
     if (FragmentCounter != 0) {
-      Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Re-linking " << *Walker << "..." << endl);
       unlink(Walker);
       molecules[FragmentCounter-1]->AddAtom(Walker);    // counting starts at 1
     } else {
-      eLog() << Verbose(0) << "Atom " << *Walker << " not associated to molecule!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Atom " << *Walker << " not associated to molecule!" << endl);
       performCriticalExit();
     }
@@ -856,5 +873,5 @@
   Free(&MolMap);
   Free(&molecules);
-  Log() << Verbose(1) << "I scanned " << FragmentCounter << " molecules." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "I scanned " << FragmentCounter << " molecules." << endl);
 };
 
@@ -893,5 +910,5 @@
   OBSERVE;
   molecule *mol = NULL;
-  mol = new molecule(periode);
+  mol = World::getInstance().createMolecule();
   insert(mol);
 };
@@ -902,5 +919,5 @@
   char filename[MAXSTRINGSIZE];
   Log() << Verbose(0) << "Format should be XYZ with: ShorthandOfElement\tX\tY\tZ" << endl;
-  mol = new molecule(periode);
+  mol = World::getInstance().createMolecule();
   do {
     Log() << Verbose(0) << "Enter file name: ";
@@ -910,10 +927,10 @@
   // center at set box dimensions
   mol->CenterEdge(&center);
-  mol->cell_size[0] = center.x[0];
-  mol->cell_size[1] = 0;
-  mol->cell_size[2] = center.x[1];
-  mol->cell_size[3] = 0;
-  mol->cell_size[4] = 0;
-  mol->cell_size[5] = center.x[2];
+  World::getInstance().getDomain()[0] = center[0];
+  World::getInstance().getDomain()[1] = 0;
+  World::getInstance().getDomain()[2] = center[1];
+  World::getInstance().getDomain()[3] = 0;
+  World::getInstance().getDomain()[4] = 0;
+  World::getInstance().getDomain()[5] = center[2];
   insert(mol);
 }
@@ -960,5 +977,5 @@
       mol = *ListRunner;
       ListOfMolecules.erase(ListRunner);
-      delete(mol);
+      World::getInstance().destroyMolecule(mol);
       break;
     }
@@ -1007,5 +1024,5 @@
   // remove the leaf itself
   if (Leaf != NULL) {
-    delete (Leaf);
+    World::getInstance().destroyMolecule(Leaf);
     Leaf = NULL;
   }
@@ -1053,13 +1070,13 @@
   int AtomNo;
 
-  Log() << Verbose(1) << "Begin of FillBondStructureFromReference." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of FillBondStructureFromReference." << endl);
   // fill ListOfLocalAtoms if NULL was given
   if (!FillListOfLocalAtoms(ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-    Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl);
     return false;
   }
 
   if (status) {
-    Log() << Verbose(1) << "Creating adjacency list for subgraph " << Leaf << "." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Creating adjacency list for subgraph " << Leaf << "." << endl);
     // remove every bond from the list
     bond *Binder = NULL;
@@ -1082,5 +1099,5 @@
             Leaf->AddBond(Walker, OtherWalker, (*Runner)->BondDegree);
         } else {
-          Log() << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << (*Runner)->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl;
+          DoLog(1) && (Log() << Verbose(1) << "OtherWalker = ListOfLocalAtoms[" << FragmentCounter << "][" << (*Runner)->GetOtherAtom(Walker->GetTrueFather())->nr << "] is NULL!" << endl);
           status = false;
         }
@@ -1095,5 +1112,5 @@
       Free(&ListOfLocalAtoms);
   }
-  Log() << Verbose(1) << "End of FillBondStructureFromReference." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of FillBondStructureFromReference." << endl);
   return status;
 };
@@ -1128,5 +1145,5 @@
         next->FillRootStackForSubgraphs(RootStack, AtomMask, ++FragmentCounter);
     } else {
-      Log() << Verbose(1) << "Rootstack[" << FragmentCounter << "] is NULL." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Rootstack[" << FragmentCounter << "] is NULL." << endl);
       return false;
     }
@@ -1134,5 +1151,5 @@
     return true;
   } else {
-    Log() << Verbose(1) << "Rootstack is NULL." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Rootstack is NULL." << endl);
     return false;
   }
@@ -1184,8 +1201,8 @@
   int KeySetCounter = 0;
 
-  Log() << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of AssignKeySetsToFragment." << endl);
   // fill ListOfLocalAtoms if NULL was given
   if (!FillListOfLocalAtoms(ListOfLocalAtoms, FragmentCounter, reference->AtomCount, FreeList)) {
-    Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Filling of ListOfLocalAtoms failed." << endl);
     return false;
   }
@@ -1215,8 +1232,8 @@
     delete (TempSet);
     if (KeySetCounter == 0) {// if there are no keysets, delete the list
-      Log() << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "KeySetCounter is zero, deleting FragmentList." << endl);
       delete (FragmentList[FragmentCounter]);
     } else
-      Log() << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << KeySetCounter << " keysets were assigned to subgraph " << FragmentCounter << "." << endl);
     FragmentCounter++;
     if (next != NULL)
@@ -1224,5 +1241,5 @@
     FragmentCounter--;
   } else
-    Log() << Verbose(1) << "KeySetList is NULL or empty." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "KeySetList is NULL or empty." << endl);
 
   if ((FreeList) && (ListOfLocalAtoms != NULL)) {
@@ -1232,5 +1249,5 @@
       Free(&ListOfLocalAtoms);
   }
-  Log() << Verbose(1) << "End of AssignKeySetsToFragment." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of AssignKeySetsToFragment." << endl);
   return status;
 };
@@ -1245,5 +1262,5 @@
 void MoleculeLeafClass::TranslateIndicesToGlobalIDs(Graph **FragmentList, int &FragmentCounter, int &TotalNumberOfKeySets, Graph &TotalGraph)
 {
-  Log() << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of TranslateIndicesToGlobalIDs." << endl);
   KeySet *TempSet = new KeySet;
   if (FragmentList[FragmentCounter] != NULL) {
@@ -1256,10 +1273,10 @@
     delete (TempSet);
   } else {
-    Log() << Verbose(1) << "FragmentList is NULL." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "FragmentList is NULL." << endl);
   }
   if (next != NULL)
     next->TranslateIndicesToGlobalIDs(FragmentList, ++FragmentCounter, TotalNumberOfKeySets, TotalGraph);
   FragmentCounter--;
-  Log() << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "End of TranslateIndicesToGlobalIDs." << endl);
 };
 
